LinuxQuestions.org
Go Job Hunting at the LQ Job Marketplace
Go Back   LinuxQuestions.org > Forums > Linux Forums > Linux - Hardware
User Name
Password
Linux - Hardware This forum is for Hardware issues.
Having trouble installing a piece of hardware? Want to know if that peripheral is compatible with Linux?

Notices

Reply
 
Search this Thread
Old 05-17-2009, 11:15 AM   #1
puttingau
LQ Newbie
 
Registered: Oct 2008
Posts: 4

Rep: Reputation: 0
Logitech Webcam (quickcam express plus) won't work with Ubuntu 8.04


I'm having a confusing time with this webcam. When I plug it in, dmesg shows it is recognised and needs the module gspca_spca561

Code:
[ 6644.595789] usb 1-6: new full speed USB device using ohci_hcd and address 4
[ 6644.707379] usb 1-6: configuration #1 chosen from 1 choice
[ 6644.752736] Linux video capture interface: v2.00
[ 6644.755290] gspca: main v2.6.0 registered
[ 6644.756667] gspca: probing 046d:092f
[ 6644.847191] gspca: probe ok
[ 6644.847213] usbcore: registered new interface driver spca561
[ 6644.847217] spca561: registered
[ 6644.860949] gspca: disagrees about version of symbol video_devdata
[ 6644.860959] gspca: Unknown symbol video_devdata
[ 6644.861179] gspca: disagrees about version of symbol video_unregister_device
[ 6644.861181] gspca: Unknown symbol video_unregister_device
[ 6644.861264] gspca: disagrees about version of symbol video_device_alloc
[ 6644.861266] gspca: Unknown symbol video_device_alloc
[ 6644.861296] gspca: disagrees about version of symbol video_register_device
[ 6644.861307] gspca: Unknown symbol video_register_device
[ 6644.861451] gspca: disagrees about version of symbol video_usercopy
[ 6644.861453] gspca: Unknown symbol video_usercopy
[ 6644.861483] gspca: disagrees about version of symbol video_device_release
[ 6644.861485] gspca: Unknown symbol video_device_release
lsmod | grep gspca shows this module is loaded:

Code:
gspca_spca561          13184  0 
gspca_main             29440  1 gspca_spca561
videodev               45216  2 compat_ioctl32,gspca_main
usbcore               170288  8 gspca_spca561,gspca_main,dvb_usb_af9015,dvb_usb,usbhid,ehci_hcd,ohci_hcd
However, there is no result in skype, ekiga, or awetv, although the device /dev/video0 is created.

A short while ago, there was a kernel update from Ubuntu 2.6.24-23-generic to 2.6.24-24-generic, and the webcam magically started working, using a different module, gspca. However, after some celebration, I found that my usb tv dongle, which uses the dvb_usb_af9015 module, ceased working.
I corrected this by recompiling the dvb_usb_af9015 module, using source from http://linuxtv.org/hg/~anttip/af9015/ ----after another celebration, I found that the webcam had stopped working again, and I have not been able to make it work since, despite recompiling the gspca module from http://mxhaard.free.fr/download.html.
Attempting to insert the gspca module produced from this gives:

Code:
insmod: error inserting 'gspca.ko': -1 Unknown symbol in module
Another thing I've noted, is that the gspca module will work when I boot into earlier kernels (eg 2.6.24-21-generic).

If anyone who has read this far can suggest what might be going on, I would appreciate it.
 
Old 05-20-2009, 01:42 AM   #2
puttingau
LQ Newbie
 
Registered: Oct 2008
Posts: 4

Original Poster
Rep: Reputation: 0
Solved

Well, I fixed it, I reinstalled the original modules and image file for Ubuntu 2.6.24-24-generic, which got the webcam working again. Here are my notes, which got the tv dongle back, in case it's a help to someone else

Quote:
I had the gspca module in quite a few locations after all this

/usr/share/EasyCam2/drivers/gspca/gspca.ko
This version of the module won't install, has symbol errors
-rw-r--r-- 1 root root 394136 2009-04-24 18:42 /lib/modules/2.6.24-24-generic/ubuntu/media/gspcav1/gspca.ko
Each version of the older kernel, through 2.6.24-19 to 2.6.24-23 has identical modules listed.

This version of the module is the one which installs OK ---the one I reinstalled with synaptic package manager.
-rw-r--r-- 1 root root 1428901 2009-05-17 14:50 /lib/modules/2.6.24-24-generic/kernel/drivers/usb/media/gspca.ko

This is almost the same one that I compiled after downloading from the mxhaard site, which also works:
pete@putting:~$ ll /home/pete/tmp/gspcav1-20071224/gspca.ko
-rw-r--r-- 1 pete pete 1428310 2009-05-15 10:16 /home/pete/tmp/gspcav1-20071224/gspca.ko

This is the lsmod output with this module loaded:

pete@putting:~$ lsmod | grep gspca
gspca 695760 1
compat_ioctl32 11136 1 gspca
videodev 30720 2 gspca
usbcore 170288 7 gspca,dvb_usb,usblp,usbhid,ehci_hcd,ohci_hcd

Here's another one, which I downloaded and compiled from the Easycam site, and has the same number of bytes as the first one above.
pete@putting:~$ ll /usr/share/EasyCam2/drivers/gspca/gspca.ko
-rw-r--r-- 1 root root 1428901 2009-05-17 14:50 /usr/share/EasyCam2/drivers/gspca/gspca.ko

It loads OK, the only difference in the lsmod is the memory used for gspca is slightly different, at 696016 bytes

Note that you can't modprobe a .ko file - eg
~$ sudo modprobe -v /usr/share/EasyCam2/drivers/gspca/gspca.ko
FATAL: Module /usr/share/EasyCam2/drivers/gspca/gspca.ko not found.

You can insmod a .ko file, but must have the dependent modules modprobed first-- find these using modinfo gspca. Then:
~$ sudo modprobe videodev
~$ sudo modprobe compat_ioctl32

Ekiga identifies it as a Logitech Quickcam EC under the v4l tab
Cheese works, but doesn't give any details.
xawtv works well, shows video source as spca561, the module that doesn't work in this situation, but probably is referring to the chip the camera uses. Shows ??? in the title bar.
Skype works, also shows it a Logitech Quickcam EC(/dev/video0)

(lsusb shows it as: ID 046d:092f Logitech, Inc. QuickCam express Plus)

So, what's going on, everything works now, but as soon as I install my leadtek USB Dongle gold, I know the webcam will be broken. I'm supposing that the some of the dependent modules get overwritten by the install, and they are different, don't support the webcam.

Following the tutorial in http://ubuntuforums.org/showthread.php?t=606487, in particular:
---------------------------------------------------------------------------------------
Re: Af9015
Install at least the following packages
build-essential
linux-headers-generic
dvb-utils

- Download the firmware to /lib/firmware/dvb-usb-af9015.fw
- remove any loaded v4l and dvb modules from your kernel
* first check what modules are loaded by issuing 'lsmod'
* remove modules by calling modprobe --remove modulename
ex: 'sudo modprobe --remove v4l2_common'
* if you get the error message "FATAL: Module v4lsomething is in use.", check which module is using it, and remove that one first.

- Download and unpack af9015-(use the latest).tar.bz2 from http://linuxtv.org/hg/~anttip/af9015/
- go to the af9015-ca6a41d1798b directory
- run `make`
- go to the subdirectory v4l (typing ls *.ko should show a whole bunch of kernel modules)
- 'sudo modprobe i2c-core'
- 'sudo insmod ./dvb-core.ko'
- 'sudo insmod ./dvb-usb.ko'
- 'sudo insmod ./mt2060.ko'
- 'sudo insmod ./qt1010.ko'
- 'sudo insmod ./af9013.ko'
- 'sudo insmod ./dvb-usb-af9015.ko'

Note: If you get something like "symbol not found (-1)" while insmod:ing the modules, check dmesg for the details and try to figure which module you are missing.
--------------------------------------------------------------------------------------------
(I noticed it was using 2.6.24-21-generic at the start of the make, so stopped it, did a "make clean", "make release", which apparently points things to the current kernel, then "make" again.)

After successfully doing this, you get an lsmod like this
dvb_usb_af9015 38848 0
dvb_usb 26508 1 dvb_usb_af9015
dvb_core 105772 1 dvb_usb
af9013 23684 1
qt1010 9092 0
mt2060 7556 0
gspca 696016 0
compat_ioctl32 11136 1 gspca
videodev 30720 1 gspca
v4l2_common 21888 2 compat_ioctl32,videodev
v4l1_compat 15492 1 videodev
dv
The tv dongle and the webcam now work together.

The next step is to reboot and try to make things automatic.
In my case, I don't need the qt1010 or mt2060 modules. the dvb_usb and dvb_core modules were a different size, so after rebooting, I removed them with modprobe -r dvb-usb (don't need to do dvb_core, it is automatic, then put them back with insmod, dvb-core.ko first, dvb-usb.ko next. Then insmod af9013.ko then dvb-usb-af9015.ko.
After that, the tv dongle was happy again.

Now that I know which modules need replacing, I copied the modules from my build directory, to the normal places they reside in /lib/modules, making a backup first:

tmp/af9015-46560e0b658e/v4l$sudo mv /lib/modules/2.6.24-24-generic/kernel/drivers/media/dvb/dvb-usb/dvb-usb.ko /lib/modules/2.6.24-24-generic/kernel/drivers/media/dvb/dvb-usb/dvb-usb.ko.buUsinNewModule (made a backup of the ubuntu produced module in case this didn't work)

tmp/af9015-46560e0b658e/v4l$ sudo cp dvb-usb.ko /lib/modules/2.6.24-24-generic/kernel/drivers/media/dvb/dvb-usb

Of course, I did this for modules dvb-core, af9013, and dvb-usb-af9015 as well.
I did a sudo depmod -a, then rebooted.
Tv dongle and webcam OK again hopefully nothing else has been ruined, and I can use these notes for the next kernel upgrade, which will probably break things again....
 
  


Reply

Tags
express, gspca, logitech, plus, symbol, unknown, webcam


Thread Tools Search this Thread
Search this Thread:

Advanced Search

Posting Rules
You may not post new threads
You may not post replies
You may not post attachments
You may not edit your posts

BB code is On
Smilies are On
[IMG] code is Off
HTML code is Off


Similar Threads
Thread Thread Starter Forum Replies Last Post
LOGITECH quickcam express hvc123 Linux - Hardware 2 04-18-2009 10:21 AM
Logitech QuickCam STX will not work on Ubuntu 8.04 gbonitz Linux - Hardware 1 04-17-2009 08:28 AM
Webcam Logitech Quickcam Express F M J Linux - Software 2 04-08-2008 07:37 PM
Does anyone know of any drivers that will work for a "Logitech, Quickcam Express - ~" echat Linux - Hardware 2 01-03-2007 05:59 PM
Logitech Quickcam Express USB Webcam... bfloeagle Linux - Hardware 7 07-22-2002 08:27 AM


All times are GMT -5. The time now is 06:14 PM.

Main Menu
My LQ
Write for LQ
LinuxQuestions.org is looking for people interested in writing Editorials, Articles, Reviews, and more. If you'd like to contribute content, let us know.
Main Menu
Syndicate
RSS1  Latest Threads
RSS1  LQ News
Twitter: @linuxquestions
identi.ca: @linuxquestions
Facebook: linuxquestions Google+: linuxquestions
Open Source Consulting | Domain Registration